package com.css.simulation.resource.common.controller;

import com.css.simulation.resource.common.pojo.parameter.MinioParameter;
import com.css.simulation.resource.common.util.MinioUtil;
import io.minio.MinioClient;
import io.minio.errors.*;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.io.IOException;
import java.io.InputStream;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;

@RestController
@RequestMapping("/minio")
public class MinioController {

    @Resource
    private MinioClient minioClient;

    @RequestMapping("/upload1")
    public void upload(
            MultipartFile multipartFile,
            @RequestBody @Validated MinioParameter minioParameter
    ) throws ServerException, InsufficientDataException, ErrorResponseException, IOException, NoSuchAlgorithmException, InvalidKeyException, InvalidResponseException, XmlParserException, InternalException {
        MinioUtil.uploadFromMultipartFile(
                minioClient,
                multipartFile,
                minioParameter.getBucketName(),
                minioParameter.getObjectName()
        );
    }

    @RequestMapping("/download")
    public InputStream download(
            @RequestBody @Validated MinioParameter minioParameter
    ) throws ServerException, InsufficientDataException, ErrorResponseException, IOException, NoSuchAlgorithmException, InvalidKeyException, InvalidResponseException, XmlParserException, InternalException {
        return MinioUtil.downloadToStream(
                minioClient,
                minioParameter.getBucketName(),
                minioParameter.getObjectName()
        );
    }

}
